function printeps(figfilestr, verbal, actualfont)

%error(nargchk(1, 4, nargin));
H_figure=gcf;
if ishandle(H_figure)
  if ~strcmpi('figure', get(H_figure,'Type'))
    error('The first parameter must be a figure handle');
  end
end

if nargin < 3
  actualfont = 'Times-Roman';
  if nargin < 2
    verbal = 1;
    if nargin < 1
      figfilestr = 'noname.eps';
    end
  end
end

if ~isnumeric(verbal)
  if strcmpi(verbal, 'verbal')
    verbal = 1;
  else
    verbal = 0;
  end
else
  if islogical(verbal)
    verbal = double(verbal);
  else
    verbal = double(abs(verbal) >= 1);
  end
end

% check if ".eps" is at the tail of a file name
if  ~strcmp(figfilestr(end-3:end),'.eps')
  figfilestr = [figfilestr '.eps'];
end
eval(['print -depsc2 -f' num2str(H_figure.Number)  ' ' figfilestr ';']);

% now read in the file
fid = fopen(figfilestr);
ff = char(fread(fid))';
fclose(fid);

%these are the only allowed fonts in MatLab and so we have to weed them out
%and replace them:
mlabfontlist = {'Helvetica','Times-Roman', 'Courier', ...
    'NewCenturySchlbk','AvantGarde','Bookman','ZapfChancery','Palatino', ...
    'ZapfDingbats',};%,'Symbol'};

if verbal ~= 0
  fprintf('\n');
end

styles = cell(2,3);
styles(1,:) = {'-BoldOblique' '-Bold' '-Oblique'};
styles(2,:) = {'-BoldItalic' '-Bold' '-Italic'};

%%% Helvetica, Times-Roman & Courier are treated separately
if strfind(ff,mlabfontlist{1})
%     ff = strrep(ff,'Helvetica Narrow','Arial');
%     ff = strrep(ff,'Helvetica-Narrow','Arial Narrow');
%     ff = strrep(ff,'HelveticaNarrow','Arial Narrow');
  ff = strrep(ff,[mlabfontlist{1} styles{1,1}],['Arial' styles{2,1}]);
  ff = strrep(ff,[mlabfontlist{1} styles{1,2}],['Arial' styles{2,2}]);
  ff = strrep(ff,[mlabfontlist{1} styles{1,3}],['Arial' styles{2,3}]);
  ff = strrep(ff,mlabfontlist{1},'Arial');
  fprintf('Font family ''%s'' has been change to ''%s''\n', ...
    mlabfontlist{1}, 'Arial');
end

if strfind(ff, mlabfontlist{2})
  ff = strrep(ff,[mlabfontlist{2} styles{1,1}],['TimeNewRoman' styles{2,1}]);
  ff = strrep(ff,[mlabfontlist{2} styles{1,2}],['TimeNewRoman' styles{2,2}]);
  ff = strrep(ff,[mlabfontlist{2} styles{1,3}],['TimeNewRoman' styles{2,3}]);
  ff = strrep(ff,mlabfontlist{2},'TimeNewRoman');
  fprintf('Font family ''%s'' has been change to ''%s''\n', ...
    mlabfontlist{2}, 'TimesNewRoman');
end

if strfind(ff, mlabfontlist{3})
  ff = strrep(ff,[mlabfontlist{3} styles{1,1}],['Arial' styles{2,1}]);
  ff = strrep(ff,[mlabfontlist{3} styles{1,2}],['Arial' styles{2,2}]);
  ff = strrep(ff,[mlabfontlist{3} styles{1,3}],['Arial' styles{2,3}]);
  ff = strrep(ff,mlabfontlist{3},actualfont);
  fprintf('Font family ''%s'' has been change to ''%s''\n', ...
    'Courier', actualfont);
end

for m=4:length(mlabfontlist)
  if strfind(ff,mlabfontlist{m})
    ff = strrep(ff,mlabfontlist{m},actualfont);
    ff = strrep(ff,[mlabfontlist{m} styles{1,1}],[actualfont styles{2,1}]);
    ff = strrep(ff,[mlabfontlist{m} styles{1,2}],[actualfont styles{2,2}]);
    ff = strrep(ff,[mlabfontlist{m} styles{1,3}],[actualfont styles{2,3}]);
    ff = strrep(ff,mlabfontlist{m},actualfont);
    fprintf('Font family ''%s'' has been change to ''%s''\n', ...
      mlabfontlist{m}, actualfont);
  end
end

if verbal ~= 0
  fprintf('\n');
end

% open the file up and overwrite it
fid = fopen(figfilestr,'w');
fprintf(fid,'%s',ff);
fclose(fid);
